/*
 * Copyright 2017-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license.
 */

package dev.ragnarok.fenrir.util.serializeble.json.internal

import java.util.concurrent.ConcurrentHashMap

/**
 * Creates a ConcurrentHashMap on JVM and regular HashMap on other platforms.
 * To make actual use of cache in Kotlin/Native, mark a top-level object with this map
 * as a @[ThreadLocal].
 */
internal fun <K, V> createMapForCache(initialCapacity: Int): MutableMap<K, V> =
    ConcurrentHashMap(initialCapacity)
