/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package dev.ragnarok.fenrir.view.emoji.section

import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromChar
import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromCodePoint

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
object Nature {
    val DATA = arrayOf(
        fromCodePoint(0x1f436),
        fromCodePoint(0x1f431),
        fromCodePoint(0x1f42d),
        fromCodePoint(0x1f439),
        fromCodePoint(0x1f430),
        fromCodePoint(0x1f43b),
        fromCodePoint(0x1f43c),
        fromCodePoint(0x1f428),
        fromCodePoint(0x1f42f),
        fromCodePoint(0x1f981),
        fromCodePoint(0x1f42e),
        fromCodePoint(0x1f437),
        fromCodePoint(0x1f43d),
        fromCodePoint(0x1f438),
        fromCodePoint(0x1f419),
        fromCodePoint(0x1f435),
        fromCodePoint(0x1f648),
        fromCodePoint(0x1f649),
        fromCodePoint(0x1f64a),
        fromCodePoint(0x1f412),
        fromCodePoint(0x1f414),
        fromCodePoint(0x1f427),
        fromCodePoint(0x1f426),
        fromCodePoint(0x1f424),
        fromCodePoint(0x1f423),
        fromCodePoint(0x1f425),
        fromCodePoint(0x1f43a),
        fromCodePoint(0x1f417),
        fromCodePoint(0x1f434),
        fromCodePoint(0x1f984),
        fromCodePoint(0x1f41d),
        fromCodePoint(0x1f41b),
        fromCodePoint(0x1f40c),
        fromCodePoint(0x1f41e),
        fromCodePoint(0x1f41c),
        fromCodePoint(0x1f577),
        fromCodePoint(0x1f982),
        fromCodePoint(0x1f980),
        fromCodePoint(0x1f40d),
        fromCodePoint(0x1f422),
        fromCodePoint(0x1f420),
        fromCodePoint(0x1f41f),
        fromCodePoint(0x1f421),
        fromCodePoint(0x1f42c),
        fromCodePoint(0x1f433),
        fromCodePoint(0x1f40b),
        fromCodePoint(0x1f40a),
        fromCodePoint(0x1f406),
        fromCodePoint(0x1f405),
        fromCodePoint(0x1f403),
        fromCodePoint(0x1f402),
        fromCodePoint(0x1f404),
        fromCodePoint(0x1f42a),
        fromCodePoint(0x1f42b),
        fromCodePoint(0x1f418),
        fromCodePoint(0x1f410),
        fromCodePoint(0x1f40f),
        fromCodePoint(0x1f411),
        fromCodePoint(0x1f40e),
        fromCodePoint(0x1f416),
        fromCodePoint(0x1f400),
        fromCodePoint(0x1f401),
        fromCodePoint(0x1f413),
        fromCodePoint(0x1f983),
        fromCodePoint(0x1f54a),
        fromCodePoint(0x1f415),
        fromCodePoint(0x1f429),
        fromCodePoint(0x1f408),
        fromCodePoint(0x1f407),
        fromCodePoint(0x1f43f),
        fromCodePoint(0x1f43e),
        fromCodePoint(0x1f409),
        fromCodePoint(0x1f432),
        fromCodePoint(0x1f335),  //Emojicon.fromChar((char)0xe033),
        fromCodePoint(0x1f332),
        fromCodePoint(0x1f333),
        fromCodePoint(0x1f334),  //Emojicon.fromChar((char)0xe110),
        fromCodePoint(0x1f33f),
        fromCodePoint(0x1f340),
        fromCodePoint(0x1f38d),
        fromCodePoint(0x1f38b),
        fromCodePoint(0x1f343),
        fromCodePoint(0x1f342),
        fromCodePoint(0x1f341),
        fromCodePoint(0x1f33e),
        fromCodePoint(0x1f33a),
        fromCodePoint(0x1f33b),
        fromCodePoint(0x1f339),
        fromCodePoint(0x1f337),
        fromCodePoint(0x1f33c),
        fromCodePoint(0x1f338),
        fromCodePoint(0x1f490),
        fromCodePoint(0x1f344),
        fromCodePoint(0x1f330),
        fromCodePoint(0x1f383),
        fromCodePoint(0x1f41a),
        fromCodePoint(0x1f578),
        fromCodePoint(0x1f30d),
        fromCodePoint(0x1f30e),
        fromCodePoint(0x1f30f),
        fromCodePoint(0x1f315),
        fromCodePoint(0x1f316),
        fromCodePoint(0x1f317),
        fromCodePoint(0x1f318),
        fromCodePoint(0x1f311),
        fromCodePoint(0x1f312),
        fromCodePoint(0x1f313),
        fromCodePoint(0x1f314),
        fromCodePoint(0x1f31a),
        fromCodePoint(0x1f31d),
        fromCodePoint(0x1f31b),
        fromCodePoint(0x1f31c),
        fromCodePoint(0x1f31e),
        fromCodePoint(0x1f319),
        fromChar(0x2b50.toChar()),  //Emojicon.fromChar((char)0xe335),
        //Emojicon.fromChar((char)0xe32e),
        //Emojicon.fromChar((char)0x2604),
        //Emojicon.fromChar((char)0x2600),
        fromCodePoint(0x1f324),
        fromChar(0x26c5.toChar()),
        fromCodePoint(0x1f325),
        fromCodePoint(0x1f326),  //Emojicon.fromChar((char)0x2601),
        fromCodePoint(0x1f327),  //Emojicon.fromChar((char)0x26c8),
        fromCodePoint(0x1f329),
        fromChar(0x26a1.toChar()),  //Emojicon.fromChar((char)0xe11d),
        fromCodePoint(0x1f4a5),
        fromChar(0x2744.toChar()),
        fromCodePoint(0x1f328),  //Emojicon.fromChar((char)0x2603),
        fromChar(0x26c4.toChar()),
        fromCodePoint(0x1f32c),
        fromCodePoint(0x1f4a8),
        fromCodePoint(0x1f32a),
        fromCodePoint(0x1f32b),  //Emojicon.fromChar((char)0x2602),
        fromChar(0x2614.toChar()),
        fromCodePoint(0x1f4a6),
        fromCodePoint(0x1f4a7),
        fromCodePoint(0x1f30a)
    )
}