/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package dev.ragnarok.fenrir.view.emoji.section

import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromChar
import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromCodePoint

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
object People {
    val DATA = arrayOf(
        fromCodePoint(0x1f600),
        fromCodePoint(0x1f62c),
        fromCodePoint(0x1f601),
        fromCodePoint(0x1f602),
        fromCodePoint(0x1f603),
        fromCodePoint(0x1f604),
        fromCodePoint(0x1f605),
        fromCodePoint(0x1f606),
        fromCodePoint(0x1f607),
        fromCodePoint(0x1f609),
        fromCodePoint(0x1f60a),
        fromCodePoint(0x1f642),
        fromCodePoint(0x1f643),
        fromChar(0x263a.toChar()),
        fromCodePoint(0x1f60b),
        fromCodePoint(0x1f60c),
        fromCodePoint(0x1f60d),
        fromCodePoint(0x1f618),
        fromCodePoint(0x1f617),
        fromCodePoint(0x1f619),
        fromCodePoint(0x1f61a),
        fromCodePoint(0x1f61c),
        fromCodePoint(0x1f61d),
        fromCodePoint(0x1f61b),
        fromCodePoint(0x1f911),
        fromCodePoint(0x1f913),
        fromCodePoint(0x1f60e),
        fromCodePoint(0x1f917),
        fromCodePoint(0x1f60f),
        fromCodePoint(0x1f636),
        fromCodePoint(0x1f610),
        fromCodePoint(0x1f611),
        fromCodePoint(0x1f612),
        fromCodePoint(0x1f644),
        fromCodePoint(0x1f914),
        fromCodePoint(0x1f633),
        fromCodePoint(0x1f61e),
        fromCodePoint(0x1f61f),
        fromCodePoint(0x1f620),
        fromCodePoint(0x1f621),
        fromCodePoint(0x1f614),
        fromCodePoint(0x1f615),
        fromCodePoint(0x1f641),  //Emojicon.fromChar((char)0x2639),
        fromCodePoint(0x1f623),
        fromCodePoint(0x1f616),
        fromCodePoint(0x1f62b),
        fromCodePoint(0x1f629),
        fromCodePoint(0x1f624),
        fromCodePoint(0x1f62e),
        fromCodePoint(0x1f631),
        fromCodePoint(0x1f628),
        fromCodePoint(0x1f630),
        fromCodePoint(0x1f62f),
        fromCodePoint(0x1f626),
        fromCodePoint(0x1f627),
        fromCodePoint(0x1f622),
        fromCodePoint(0x1f625),
        fromCodePoint(0x1f62a),
        fromCodePoint(0x1f613),
        fromCodePoint(0x1f62d),
        fromCodePoint(0x1f635),
        fromCodePoint(0x1f632),
        fromCodePoint(0x1f910),
        fromCodePoint(0x1f637),
        fromCodePoint(0x1f912),
        fromCodePoint(0x1f915),
        fromCodePoint(0x1f634),
        fromCodePoint(0x1f4a4),
        fromCodePoint(0x1f4a9),
        fromCodePoint(0x1f608),
        fromCodePoint(0x1f47f),
        fromCodePoint(0x1f479),
        fromCodePoint(0x1f47a),
        fromCodePoint(0x1f480),
        fromCodePoint(0x1f47b),
        fromCodePoint(0x1f47d),
        fromCodePoint(0x1f916),
        fromCodePoint(0x1f63a),
        fromCodePoint(0x1f638),
        fromCodePoint(0x1f639),
        fromCodePoint(0x1f63b),
        fromCodePoint(0x1f63c),
        fromCodePoint(0x1f63d),
        fromCodePoint(0x1f640),
        fromCodePoint(0x1f63f),
        fromCodePoint(0x1f63e),
        fromCodePoint(0x1f64c),
        fromCodePoint(0x1f44f),
        fromCodePoint(0x1f44b),
        fromCodePoint(0x1f44d),
        fromCodePoint(0x1f44e),
        fromCodePoint(0x1f44a),
        fromChar(0x270a.toChar()),
        fromChar(0x270c.toChar()),
        fromCodePoint(0x1f44c),
        fromChar(0x270b.toChar()),
        fromCodePoint(0x1f450),
        fromCodePoint(0x1f4aa),
        fromCodePoint(0x1f64f),  //Emojicon.fromChar((char)0x261d),
        fromCodePoint(0x1f446),
        fromCodePoint(0x1f447),
        fromCodePoint(0x1f448),
        fromCodePoint(0x1f449),
        fromCodePoint(0x1f595),
        fromCodePoint(0x1f590),
        fromCodePoint(0x1f918),  //Emojicon.fromChar((char)0x270d),
        fromCodePoint(0x1f485),
        fromCodePoint(0x1f444),
        fromCodePoint(0x1f445),
        fromCodePoint(0x1f442),
        fromCodePoint(0x1f443),
        fromCodePoint(0x1f441),
        fromCodePoint(0x1f440),
        fromCodePoint(0x1f464),
        fromCodePoint(0x1f465),
        fromCodePoint(0x1f5e3),
        fromCodePoint(0x1f476),
        fromCodePoint(0x1f466),
        fromCodePoint(0x1f467),
        fromCodePoint(0x1f468),
        fromCodePoint(0x1f469),
        fromCodePoint(0x1f471),
        fromCodePoint(0x1f474),
        fromCodePoint(0x1f475),
        fromCodePoint(0x1f472),
        fromCodePoint(0x1f473),
        fromCodePoint(0x1f46e),
        fromCodePoint(0x1f477),
        fromCodePoint(0x1f482),
        fromCodePoint(0x1f575),
        fromCodePoint(0x1f385),
        fromCodePoint(0x1f47c),
        fromCodePoint(0x1f478),
        fromCodePoint(0x1f470),
        fromCodePoint(0x1f6b6),
        fromCodePoint(0x1f3c3),
        fromCodePoint(0x1f483),
        fromCodePoint(0x1f46f),
        fromCodePoint(0x1f525),
        fromChar(0x2728.toChar()),
        fromCodePoint(0x1f31f),
        fromCodePoint(0x1f4ab),
        fromCodePoint(0x1f4a2),
        fromCodePoint(0x1f46b),
        fromCodePoint(0x1f46c),
        fromCodePoint(0x1f46d),
        fromCodePoint(0x1f647),
        fromCodePoint(0x1f481),
        fromCodePoint(0x1f645),
        fromCodePoint(0x1f646),
        fromCodePoint(0x1f64b),
        fromCodePoint(0x1f64e),
        fromCodePoint(0x1f64d),
        fromCodePoint(0x1f487),
        fromCodePoint(0x1f486),
        fromCodePoint(0x1f491),
        fromCodePoint(0x1f48f),
        fromCodePoint(0x1f46a),
        fromCodePoint(0x1f45a),
        fromCodePoint(0x1f455),
        fromCodePoint(0x1f456),
        fromCodePoint(0x1f454),
        fromCodePoint(0x1f457),
        fromCodePoint(0x1f459),
        fromCodePoint(0x1f458),
        fromCodePoint(0x1f484),
        fromCodePoint(0x1f48b),
        fromCodePoint(0x1f463),
        fromCodePoint(0x1f460),
        fromCodePoint(0x1f461),
        fromCodePoint(0x1f462),
        fromCodePoint(0x1f45e),
        fromCodePoint(0x1f45f),
        fromCodePoint(0x1f452),
        fromCodePoint(0x1f3a9),
        fromCodePoint(0x1f393),
        fromCodePoint(0x1f451),  //Emojicon.fromChar((char)0x26d1),
        //Emojicon.fromChar((char)0xe43a),
        fromCodePoint(0x1f45d),
        fromCodePoint(0x1f45b),
        fromCodePoint(0x1f45c),
        fromCodePoint(0x1f4bc),
        fromCodePoint(0x1f453),
        fromCodePoint(0x1f576),
        fromCodePoint(0x1f48d),
        fromCodePoint(0x1f302)
    )
}