/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package dev.ragnarok.fenrir.view.emoji.section

import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromChar
import dev.ragnarok.fenrir.view.emoji.section.Emojicon.Companion.fromCodePoint

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
object Symbols {
    val DATA = arrayOf(
        fromChar(0x2764.toChar()),
        fromCodePoint(0x1f49b),
        fromCodePoint(0x1f49a),
        fromCodePoint(0x1f499),
        fromCodePoint(0x1f49c),
        fromCodePoint(0x1f494),  //Emojicon.fromChar((char)0x2763),
        fromCodePoint(0x1f495),
        fromCodePoint(0x1f49e),
        fromCodePoint(0x1f493),
        fromCodePoint(0x1f497),
        fromCodePoint(0x1f496),
        fromCodePoint(0x1f498),
        fromCodePoint(0x1f49d),
        fromCodePoint(0x1f49f),  //Emojicon.fromChar((char)0x262e),
        //Emojicon.fromChar((char)0x271d),
        //Emojicon.fromChar((char)0x262a),
        fromCodePoint(0x1f549),  //Emojicon.fromChar((char)0x2638),
        fromCodePoint(0x1f54e),  //Emojicon.fromChar((char)0x262f),
        fromCodePoint(0x1f233),
        fromCodePoint(0x1f239),  //Emojicon.fromChar((char) 0xe532),
        //Emojicon.fromChar((char) 0xe533),
        //Emojicon.fromChar((char) 0xe534),
        //Emojicon.fromChar((char) 0xe535),
        fromCodePoint(0x1f250),  //Emojicon.fromChar((char)0x3299),
        //Emojicon.fromChar((char)0x3297),
        fromCodePoint(0x1f234),
        fromCodePoint(0x1f232),
        fromCodePoint(0x1f191),
        fromCodePoint(0x1f198),
        fromChar(0x26d4.toChar()),
        fromCodePoint(0x1f4db),
        fromCodePoint(0x1f6ab),
        fromChar(0x274c.toChar()),
        fromChar(0x2b55.toChar()),  //Emojicon.fromChar((char) 0xe334),
        fromCodePoint(0x1f51e),
        fromCodePoint(0x1f4f5),
        fromCodePoint(0x1f6af),
        fromCodePoint(0x1f6b1),
        fromCodePoint(0x1f6b3),
        fromCodePoint(0x1f6b7),  //Emojicon.fromChar((char)0x203c),
        //Emojicon.fromChar((char)0x2049),
        fromChar(0x2757.toChar()),
        fromChar(0x2753.toChar()),
        fromChar(0x2755.toChar()),
        fromChar(0x2754.toChar()),
        fromCodePoint(0x1f4af),  //Emojicon.fromChar((char) 0xe252),
        fromCodePoint(0x1f6b8),
        fromCodePoint(0x1f506),
        fromCodePoint(0x1f505),
        fromCodePoint(0x1f531),
        fromCodePoint(0x1f530),  //Emojicon.fromChar((char)0x267b),
        //Emojicon.fromChar((char)0x2733),
        //Emojicon.fromChar((char)0x2747),
        fromChar(0x274e.toChar()),
        fromChar(0x2705.toChar()),
        fromCodePoint(0x1f4b9),
        fromCodePoint(0x1f300),
        fromCodePoint(0x1f6be),
        fromCodePoint(0x1f6b0),  //Emojicon.fromCodePoint(0x1f17f),
        fromChar(0x267f.toChar()),
        fromCodePoint(0x1f6ad),  //Emojicon.fromCodePoint(0x1f202),
        //Emojicon.fromChar((char)0x24c2),
        fromCodePoint(0x1f6c2),
        fromCodePoint(0x1f6c4),
        fromCodePoint(0x1f6c5),
        fromCodePoint(0x1f6c3),
        fromCodePoint(0x1f6b9),
        fromCodePoint(0x1f6ba),
        fromCodePoint(0x1f6bc),
        fromCodePoint(0x1f6bb),
        fromCodePoint(0x1f6ae),  /*        Emojicon.fromChar((char) 0xe225),
                    Emojicon.fromChar((char) 0xe21c),
                    Emojicon.fromChar((char) 0xe21d),
                    Emojicon.fromChar((char) 0xe21e),
                    Emojicon.fromChar((char) 0xe21f),
                    Emojicon.fromChar((char) 0xe220),
                    Emojicon.fromChar((char) 0xe221),
                    Emojicon.fromChar((char) 0xe222),
                    Emojicon.fromChar((char) 0xe223),
                    Emojicon.fromChar((char)0xe224),
            */
        fromCodePoint(0x1f51f),
        fromCodePoint(0x1f522),
        fromCodePoint(0x1f523),  /*        Emojicon.fromChar((char)0x2b06),
                    Emojicon.fromChar((char)0x2b07),
                    Emojicon.fromChar((char)0x2b05),
                    Emojicon.fromChar((char)0x27a1),
            */
        fromCodePoint(0x1f520),
        fromCodePoint(0x1f521),
        fromCodePoint(0x1f524),  /*        Emojicon.fromChar((char)0x2197),
                    Emojicon.fromChar((char)0x2196),
                    Emojicon.fromChar((char)0x2198),
                    Emojicon.fromChar((char)0x2199),
                    Emojicon.fromChar((char)0x2194),
                    Emojicon.fromChar((char)0x2195),
            */
        fromCodePoint(0x1f504),
        fromChar(0x25c0.toChar()),
        fromChar(0x25b6.toChar()),  //        Emojicon.fromCodePoint(0x1f53c),
        //        Emojicon.fromCodePoint(0x1f53d),
        fromChar(0x21a9.toChar()),
        fromChar(0x21aa.toChar()),  //        Emojicon.fromChar((char)0x2139),
        //        Emojicon.fromChar((char)0x23ea),
        //        Emojicon.fromChar((char)0x23e9),
        fromChar(0x23ed.toChar()),
        fromChar(0x23ef.toChar()),  //        Emojicon.fromChar((char)0x23ee),
        fromChar(0x23f8.toChar()),
        fromChar(0x23f9.toChar()),
        fromChar(0x23fa.toChar()),
        fromChar(0x23eb.toChar()),
        fromChar(0x23ec.toChar()),  //Emojicon.fromChar((char)0x2935),
        //Emojicon.fromChar((char)0x2934),
        fromCodePoint(0x1f197),
        fromCodePoint(0x1f500),
        fromCodePoint(0x1f501),
        fromCodePoint(0x1f502),
        fromCodePoint(0x1f195),
        fromCodePoint(0x1f199),
        fromCodePoint(0x1f192),
        fromCodePoint(0x1f193),
        fromCodePoint(0x1f196),
        fromCodePoint(0x1f4f6),
        fromCodePoint(0x1f3a6),
        fromCodePoint(0x1f201),
        fromCodePoint(0x1f4b2),
        fromCodePoint(0x1f4b1),
        fromChar(0x00a9.toChar()),
        fromChar(0x00ae.toChar()),
        fromChar(0x2122.toChar()),
        fromCodePoint(0x1f51d),
        fromCodePoint(0x1f51a),
        fromCodePoint(0x1f519),
        fromCodePoint(0x1f51b),
        fromCodePoint(0x1f51c),
        fromCodePoint(0x1f503),
        fromChar(0x2716.toChar()),
        fromChar(0x2795.toChar()),
        fromChar(0x2796.toChar()),
        fromChar(0x2797.toChar()),
        fromChar(0x2714.toChar()),
        fromChar(0x2611.toChar()),
        fromCodePoint(0x1f518),
        fromChar(0x27b0.toChar()),
        fromCodePoint(0x1f4ae),
        fromChar(0x25fc.toChar()),
        fromChar(0x25fb.toChar()),
        fromChar(0x25fe.toChar()),
        fromChar(0x25fd.toChar()),
        fromChar(0x25aa.toChar()),
        fromChar(0x25ab.toChar()),
        fromCodePoint(0x1f53a),
        fromCodePoint(0x1f532),
        fromCodePoint(0x1f533),
        fromChar(0x26ab.toChar()),
        fromChar(0x26aa.toChar()),
        fromCodePoint(0x1f534),
        fromCodePoint(0x1f535),
        fromCodePoint(0x1f53b),
        fromChar(0x2b1c.toChar()),
        fromChar(0x2b1b.toChar()),
        fromCodePoint(0x1f536),
        fromCodePoint(0x1f537),
        fromCodePoint(0x1f538),
        fromCodePoint(0x1f539),
        fromCodePoint(0x1f50a),
        fromCodePoint(0x1f509),
        fromCodePoint(0x1f508),
        fromCodePoint(0x1f507),
        fromCodePoint(0x1f514),
        fromCodePoint(0x1f515),
        fromCodePoint(0x1f4e2),
        fromCodePoint(0x1f4e3),
        fromCodePoint(0x1f0cf),
        fromCodePoint(0x1f004),
        fromChar(0x2660.toChar()),
        fromChar(0x2665.toChar()),
        fromChar(0x2663.toChar()),
        fromChar(0x2666.toChar()),
        fromCodePoint(0x1f3b4),
        fromCodePoint(0x1f4ac),
        fromCodePoint(0x1f5ef),
        fromCodePoint(0x1f4ad),
        fromCodePoint(0x1f55b),
        fromCodePoint(0x1f567),
        fromCodePoint(0x1f550),
        fromCodePoint(0x1f55c),
        fromCodePoint(0x1f551),
        fromCodePoint(0x1f55d),
        fromCodePoint(0x1f552),
        fromCodePoint(0x1f55e),
        fromCodePoint(0x1f553),
        fromCodePoint(0x1f55f),
        fromCodePoint(0x1f554),
        fromCodePoint(0x1f560),
        fromCodePoint(0x1f555),
        fromCodePoint(0x1f556),
        fromCodePoint(0x1f557),
        fromCodePoint(0x1f558),
        fromCodePoint(0x1f559),
        fromCodePoint(0x1f55a),
        fromCodePoint(0x1f561),
        fromCodePoint(0x1f562),
        fromCodePoint(0x1f563),
        fromCodePoint(0x1f564),
        fromCodePoint(0x1f565),
        fromCodePoint(0x1f566)
    )
}